/*
 * ValorCampoSegunFechaNacDependiente.java
 *
 * Created on 24 de marzo de 2007, 09:39 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.StringTokenizer;

import com.fidufosyga.rules.util.ObtenerDiasEntreFechas;
import com.fidufosyga.rules.util.ValidarFecha;

// 9,N07,8,D#E
/**
 * 
 * @author Julian
 */
public class ValorCampoSegunFechaNacDependienteV2 extends AbstractRule {
	String DATE_FORMAT = "dd/MM/yyyy";

	SimpleDateFormat sdf;

	// Create object of SimpleDateFormat and pass the desired date format.
	public void setParams(Object[] params) {
		String valores = (String) params[3];
		ArrayList<String> listaString = new ArrayList<String>();
		StringTokenizer st = new StringTokenizer(valores, ",");
		while (st.hasMoreTokens()) {
			listaString.add(st.nextToken());
		}
		String[] array = listaString.toArray(new String[listaString.size()]);
		Arrays.sort(array);
		params[3] = array;
		super.setParams(params);
	}

	/** Creates a new instance of CampoVacio */
	public ValorCampoSegunFechaNacDependienteV2() {
		sdf = new SimpleDateFormat(DATE_FORMAT);
		sdf.setLenient(false);
	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {
		String codigoNovedad = registro[new Integer((String) getParams()[0])
				.intValue()];
		if (codigoNovedad.equals((String) getParams()[1])) {

			String FechaNacimiento = registro[new Integer(
					(String) getParams()[2]).intValue()];
			if (!ValidarFecha.esFecha(FechaNacimiento))
				return false;
			Date dateNacimiento = null;

			try {
				dateNacimiento = sdf.parse(FechaNacimiento);

			} catch (Exception e) {
				return false;
			}
			if (field.length() > 0)
				if (Arrays.binarySearch((String[]) getParams()[3], field) < 0) {
					return true;
				}
			// EACG.30/03/2009.INI.A19115.Ajustes Malla Validadora, Fecha
			// Nacimiento contra Fecha Novedad
			String FechaNovedad = registro[new Integer((String) getParams()[4])
					.intValue()];
			if (!ValidarFecha.esFecha(FechaNovedad))
				return false;
			Date dateFechaNovedad = null;
			try {
				dateFechaNovedad = sdf.parse(FechaNovedad);
			} catch (Exception e) {
				return false;
			}

			// double annos = Math.floor(ObtenerDiasEntreFechas.calcular(
			// dateNacimiento, Calendar.getInstance().getTime()) / 365);
			double annos = Math.floor(ObtenerDiasEntreFechas.calcular(
					dateNacimiento, dateFechaNovedad) / 365);
			// EACG.30/03/2009.FIN.A19115.

			if (annos > 18 && annos < 26 && field.equals("E")) {
				return false;

			} else if (annos > 18 && field.equals("D")) {
				return false;
			} else if (annos < 18) {
				if (field.length() > 0) {
					return true;
				}
				return false;

			}
			return true;
		}
		return false;
	}

}
